<template>
  <input
    v-if="mask"
    :id="id"
    v-model="currentValue"
    v-mask="mask"
    class="dibs--form--input dibs--form--input--text"
    :type="type"
    :max="max"
    :min="min"
    :placeholder="placeholder"
  />
  <input
    v-else
    :id="id"
    v-model="currentValue"
    class="dibs--form--input dibs--form--input--text"
    :type="type"
    :max="max"
    :min="min"
    :placeholder="placeholder"
  />
</template>
<script>
import { mask } from 'vue-the-mask'
export default {
  directives: { mask },
  props: {
    id: {
      type: [String],
      required: true,
    },
    default: {
      type: [String, Number],
      default: null,
    },
    mask: {
      type: [String],
      required: false,
      default: '',
    },
    placeholder: {
      type: [String],
      required: false,
      default: null,
    },
    type: {
      type: [String],
      default: 'text',
    },
    max: {
      type: [Number],
      default: null,
    },
    min: {
      type: [Number],
      default: null,
    },
  },
  data() {
    return {
      currentValue: this.default,
    }
  },
  watch: {
    currentValue(value) {
      this.$emit('input', value)
    },
  },
}
</script>
